<?php
// No direct access.
defined('_JEXEC') or die;

class plgJcommentsFc_jc_counter extends JPlugin
{
	/**
	 * Constructor
	 *
	 * @access      protected
	 * @param       object  $subject The object to observe
	 * @param       array   $config  An array that holds the plugin configuration
	 * @since       1.5
	 */
	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		$this->loadLanguage();
	}

	public function onJCommentsCommentAfterAdd($comment)
	{
        if($comment->object_group != 'com_flexicontent')
            return;
        $this->updateComments($comment->object_id);
	}

    public function onJCommentsCommentAfterDelete($comment)
	{
        if($comment->object_group != 'com_flexicontent')
            return;
        $this->updateComments($comment->object_id);
	}

    public function onJCommentsCommentAfterPublish($comment)
	{
        if($comment->object_group != 'com_flexicontent')
            return;
        $this->updateComments($comment->object_id);
	}


	/**
	 * @return	void
	 * @since	1.6
	 */
	protected function updateComments($object_id)
	{
        $field = $this->params->get('field', 0);

        if($field == 0){
            return;
        }


        //запрашиваетм комментарии к статье
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('`id`, `published`');
        $query->from('#__jcomments');
        $query->where('object_group="com_flexicontent"');
        $query->where('object_id="'.$object_id.'"');
        $db->setQuery((string)$query);
        $comments = $db->loadObjectList();

        //просчитвыаем опубликованные и неопубликованные комментарии
        $pubComments = $noPubComments = 0;
        if(count($comments)){
            foreach($comments as $comment){
                ($comment->published ==0) ? $noPubComments++ : $pubComments++;
            }
        }
        //выводим счетчики в строку
        $counters = json_encode(
            array(
                'pub_comments'   => $pubComments,
                'nopub_comments' => $noPubComments
            )
        );

        //удаляем значения поля для статьи
        $query = $db->getQuery(true);
        $query->delete();
     	$query->from('#__flexicontent_fields_item_relations');
        $query->where('`field_id` = '.(int) $field);
        $query->where('`item_id` = '.(int) $object_id);
        $db->setQuery((string)$query);
        $db->query();

        //добавляем новые данные
        $query = $db->getQuery(true);
        $query->insert('#__flexicontent_fields_item_relations');
        $query->set('`field_id` = '.(int) $field);
        $query->set('`item_id` = '.(int) $object_id);
        $query->set('`value` = "'. $db->escape($counters) .'"');
        $query->set('`valueorder` = 1');
        $db->setQuery((string)$query);
        $db->query();
	}
}
