<?php
/**
 * @version 1.0 $Id: fcpagenav.php 1072 2011-12-26 13:27:52Z ggppdk $
 * @package Joomla
 * @subpackage FLEXIcontent
 * @subpackage plugin.file
 * @copyright (C) 2009 Emmanuel Danan - www.vistamedia.fr
 * @license GNU/GPL v2
 *
 * FLEXIcontent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.plugin.plugin');
//jimport('joomla.event.event');

class plgFlexicontent_fieldsJcomments extends JPlugin
{
	function plgFlexicontent_fieldsJcomments( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		JPlugin::loadLanguage('plg_flexicontent_fields_jcomments', JPATH_ADMINISTRATOR);
	}

	function onAdvSearchDisplayField(&$field, &$item)
    {
			$value = JRequest::get($field->name, '');
			$field->html	= '<input name="'.$field->name.'[]" id="'.$field->name.'" class="inputbox" type="text" size="30" value="'.$value.'" />';
	}

	function onDisplayFieldValue(&$field, $item, $values=null, $prop='display')
	{
        $field->label = JText::_($field->label);
        // execute the code only if the field type match the plugin type
        if($field->field_type != 'jcomments') return;

        $css = JURI::base().'plugins/flexicontent_fields/jcomments/jcomments/style.css';
	    $document =& JFactory::getDocument();
	    $document->addStyleSheet($css);
        
        //настройки
        $mode		    = $field->parameters->get( 'mode', 1);
        $show_nopub		= $field->parameters->get( 'show_nopub', 0);

        $title = JText::_('FJCOMMENTS_TOLTIP');
        if($show_nopub == 1){
            $title = JText::_('FJCOMMENTS_TOLTIP_NOPUB');
        }
        
        $count = 0;
        
        if($mode == 1 && $show_nopub == 0){
            $count = $this->autonomPubCounter($item->id);
        }
        elseif($mode == 1 && $show_nopub == 1){
            $count = $this->autonomCounter($item->id);
        }
        elseif($mode == 0){

            $value = $values ? $values : $field->value;
            $count = (count($value)>0) ? json_decode($value[0], 1) : array();

            if($show_nopub == 1){
                $count = (count($count)>0) ? $count['pub_comments'].'('.$count['nopub_comments'].')' : '0(0)';
            }
            else{
                $count = (count($count)>0) ? $count['pub_comments'] : 0;
            }
        }
        $field->{$prop} = '<span class="jc_count" title="'.$title.'">'. $count . '</span>';
	}

    private function autonomPubCounter($id){
        $db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('COUNT(*)');
		$query->from('#__jcomments');
        $query->where('object_id="'.$id.'"');
		$query->where('object_group="com_flexicontent"');
		$query->where('published=1');
		$db->setQuery($query);
		return (int)$db->loadResult();
    }

    private function autonomCounter($id){
        $db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('`published`');
		$query->from('#__jcomments');
		$query->where('object_group="com_flexicontent"');
		$query->where('object_id="'.$id.'"');
		$db->setQuery($query);
		$comments = $db->loadObjectList();

        //просчитвыаем опубликованные и неопубликованные комментарии
        $pubComments = $noPubComments = 0;
        if(count($comments)){
            foreach($comments as $comment){
                ($comment->published ==0) ? $noPubComments++ : $pubComments++;
            }
        }
        return $pubComments.'('.$noPubComments.')';
    }
}